## Shell session caching

A central change in XPipe 13 are the improvements of reusability of shell sessions running in the background. Whenever you access a system or a parent system, XPipe will connect to it just as before but keep this session open in the background for some time, under the assumption that users will typically perform multiple actions afterward. This will improve the speed of many actions and also results in less authentication prompts when you are using something like 2FA.

A common example would be stopping and starting a container. Previously this would have resulted in two connections to the container host system and would have taken a while. Now, there will only be one connection to the host and all actions you perform on that host will be significantly quicker.

## KVM

There is now support for KVM/QEMU virtual machines that can be accessed via the libvirt CLI tools `virsh`. This includes support for other driver URLs as well aside from KVM and QEMU.

## Security updates

There's now a new mechanism in place for checking for security updates separately from the normal update check. This is important going forward, to be able to act quickly when any security patch is published so that all users have the possibility to get notified even if they don't follow announcements on the GitHub repo or on Discord. You can also disable this functionality if you want.

## Other

- There is now an intro to scripts to provide some more information before using scripts
- Some style elements have been reworked

## Fixes

- Fix vmware integration failing when files other than vmx were in the VM directories
- Fix issues with test command by using its absolute path
- Fix color contrast for some themes
- Fix system dark mode changes not being applied if they were changed while XPipe was not running
- Fix shell environment scan restarting shell connection multiple times
- Fix zsh local shell freezing if a zsh extension had a pending update
